#!/bin/bash

#if [ ! -f "$1" ]; then
#    echo "Must supply an infile name!"
#    exit 2
#fi

#infile="$1"

FILES=hmp/*.hmp

cat <<EOF
/* Automatically generated Hershey font mappings */

#include "fontgen.h"
#include <stdio.h>

EOF
unmangle(){
    for n in `cat`; do
	if  echo $n | grep -q '-' ; then
	    from=`echo $n | sed 's/\([0-9]*\)-\([0-9]*\)/\1/g'`
	    to=`echo $n | sed 's/\([0-9]*\)-\([0-9]*\)/\2/g'`
	    i=$from
	    while [ $i -le $to ]; do
		echo $i
		i=$(($i+1))
	    done
	    
	else echo $n
	fi
    done
}

block(){
    echo -e "\n/* Font map for $1 */"
    numbers=`cat`
    i=0
    echo -ne "int $1_map[]=\n         {" 
    for n in $numbers; do
	echo -n "$n"
	if [ $i != 95 ]; then
	    echo -n ","
	    if [ $(($i%8)) -eq 7 ]; then
		echo -ne "\n          "
	    fi
	fi
	i=$(($i+1))
    done
    echo "};"
}

for n in $FILES; do
    name=`basename $n .hmp`
    cat $n | unmangle | block $name
done

cat <<EOF


/* And now the ready to use fonts */
EOF

for n in $FILES; do
    name=`basename $n .hmp`
    echo "pl_font font_$name;"
done

cat <<EOF


/* Initialisation routine */

void font_init(){
EOF

for n in $FILES; do
    name=`basename $n .hmp`
    mapname=`basename $n .hmp`_map
    
    echo "  font_$name=assemble_font(' ',96,$mapname);"
done

echo -e "}\n/* End. */"
