#!/bin/bash

IFS="
"
cat <<EOF
#include <stdio.h>
#include "fontgen.h"

EOF

glyphs=
no_glyphs=0
number=31
cont=1

if [ ! "$1" ]; then
    name="hershey"
else
    name=$1
fi

while [ $cont == 1 ] ; do
   if ! line=`line`; then cont=0; fi
#   number=$((`echo $line | cut -b 1-5`))
   number=$(($number+1))
   echo proc: $number 1>&2
   size=$((`echo $line | cut -b 6-8`))
#   echo "-$number-$size-"
   plabel=`echo -n "points_"; echo -n "$name"; echo -n "_"; echo -n "$number"` 
   echo "static pl_point $plabel[]={"   
   i=0
   while [ $i -lt $size ]; do
       c1=`echo $line | cut -b $((9+$i*2))| sed 's/\\\\/\\\\\\\\/g'`
       c2=`echo $line | cut -b $((10+$i*2))| sed 's/\\\\/\\\\\\\\/g'`
       
       echo -n "                            {.p_data=(((int)'$c1')<<8)+('$c2')}"
       if [ $i -lt $(($size-1)) ]; then
	   echo ","
       fi
       i=$(($i+1))
   done
   echo -e "\n                           };"

   glyphs+=`echo -e "\n{.gl_size=$size,.gl_points=$plabel,.gl_number=$number}"`
   no_glyphs=$(($no_glyphs+1))
done

echo -e "\n\npl_glyph ${name}_glyphs[]={"
g=0
for n in $glyphs; do
    g=$(($g+1))
    echo -n "                          $n"
    if [ $g -eq $(($no_glyphs)) ]; then
	echo
    else
	echo ","
    fi
done
echo "                         };"
echo -e "\n\n"

echo "pl_font font_$name={"
echo "                       .f_label=\"PL\$FNT\","
echo "                       .f_size=$no_glyphs,"
echo "                       .f_glyphs=${name}_glyphs"
echo "                      };"


echo -e "\n/* End. */"
