/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/03/26 01:00:40 $
 * $Author: hachti $
 *
 * $Log: eot_block.cpp,v $
 * Revision 2.0  2007/03/26 01:00:40  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 
#include <string>
#include <vector>

#include "eot_block.hh"
#include "tape_block.hh"

using namespace std;

/***************************************************************/
/*!
 *\brief Copy constructor.
 */
eot_block::eot_block(eot_block & org){
  operator=(org);
  m_has_known_type=true;
}

/***************************************************************/
/*!
 *\brief Get a cleartext description of the block.
 *\return ldc style descriptive line for the block
 */
vector<string> eot_block:: get_description(){
  vector<string> result;
  string r_string="***********(EOT)*****End of Tape mark **********************";
  result.insert(result.end(),r_string);
  return result;
}

/***************************************************************/
/*!
 *\brief Specialisation constructor
 */
eot_block::eot_block(tape_block & org)
  : tape_block(org)
{}

/***************************************************************/
/*!
 *\brief Default constructor.
 */
eot_block::eot_block(){}
